
/*
	~vZiVQOj
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>


/*
	USART0 ݒȉój
*/
static void usart_init()
{

	UCSR0A  |= 1<<U2X0;
    UCSR0B  = 0;
    UCSR0C  = 3<<UCSZ00;
    UBRR0L  = 1000000 / 4800 - 1;
    UBRR0H  = 0;
    UCSR0B  = (1<<TXEN0);
}


static void _putc( char c )
{

	if( c=='\n' ) {
    	while( (UCSR0A&(1<<UDRE0))==0 )
		;
    	UDR0    = '\r';
	}

    while( (UCSR0A&(1<<UDRE0))==0 )
	;
    UDR0    = (unsigned char)c;
}


static void _puts_P( PGM_P str )
{
	char	c;

    while( (c=pgm_read_byte(str++))!=0 )
        _putc( c );
}


/*
	Timer0 ݒiEHb`hbO^C}̃NAj
*/
ISR( TIMER0_COMPA_vect )
{
    wdt_reset();
}


static void timer_init()
{

	OCR0A   = 249;          /* 32mS	*/
	TCCR0A  = 2;
	TCCR0B  = 5;            /* 1/1024	*/
	TIMSK0  |= (1<<OCIE0A);
}


/***********************************************************
	multprec.c -- {Z

	CɂŐVASYT@F
***********************************************************/

#define RADIXBITS 15                    /* ̃rbg */
#define RADIX (1U << RADIXBITS)                   /*  */
#define N  160    /* RADIXi@ŏNʂ܂ */
#define M  180    /* 10iŏ 4~M ʂ܂ */

typedef unsigned int   uint;    /* 16rbgȏ */
typedef unsigned short ushort;  /* 16rbgȏ */
typedef unsigned long  ulong;   /* 32rbgȏ */

void error(char message[])
{
	_puts_P(message);
	_putc('\n');

	for(;;)
	;
}

void add(ushort a[], ushort b[], ushort c[])
{
	int i;
	uint u;

	u = 0;
	for (i = N; i >= 0; i--) {
		u += a[i] + b[i];
		c[i] = u & (RADIX - 1);  u >>= RADIXBITS;
	}
	if (u) error(PSTR("Overflow"));
}

void sub(ushort a[], ushort b[], ushort c[])
{
	int i;
	uint u;

	u = 0;
	for (i = N; i >= 0; i--) {
		u = a[i] - b[i] - u;
		c[i] = u & (RADIX - 1);
		u = (u >> RADIXBITS) & 1;
	}
	if (u) error(PSTR("Overflow"));
}

void muls(ushort a[], uint x, ushort b[])
{
	int i;
	ulong t;

	t = 0;
	for (i = N; i >= 0; i--) {
		t += (ulong) a[i] * x;
		b[i] = (uint) t & (RADIX - 1);  t >>= RADIXBITS;
	}
	if (t) error(PSTR("Overflow"));
}

int divs(int m, ushort a[], uint x, ushort b[])
{
	int i;
	ulong t;

	t = 0;
	for (i = m; i <= N; i++) {
		t = (t << RADIXBITS) + a[i];
		b[i] = t / x;  t %= x;
	}
	if (2 * t >= x)  /* ľܓ */
		for (i = N; ++b[i] & RADIX; i--) b[i] &= RADIX - 1;
	return (b[m] != 0) ? m : (m + 1);  /* 0łȂōʒu */
}

void print(ushort a[])
{
	int     i, j;
    ushort  k, d;

	_puts_P(PSTR("\n\n\t"));
    _putc('0'+a[0]);
    _putc('.');

    j = 50;
	for (i = 0; i < M; i++) {
		a[0] = 0;  muls(a, 10000, a);
/*		printf("%04u", a[0]);	*/

        k   = a[0];
		d	= 1000;

		for( d=1000; d; d/=10 ) {
        	_putc('0'+k/d);
        	k   %= d;

			/*	50Ƃɉs	*/
			if( --j==0 ) {
	        	_puts_P(PSTR("\n\t  "));
	            j   = 50;
			}
        }    
	}
	_putc('\n');
	_putc('\n');
}

ushort a[N+1], t[N+1], u[N+1];  /* e() Ȃ u[] ͕sv. */


void pi(void)  /* ~ (Machiň) */
{
	int i, m;
	uint k;

	_putc('\n');
	t[0] = 16;  for (i = 1; i <= N; i++) t[i] = 0;   /* t := 16 */
	divs(0, t, 5, t);                                /* t := t/5 */
	for (i = 0; i <= N; i++) a[i] = t[i];            /* a := t */
	i = m = 0;  k = 1;
	for ( ; ; ) {
		if ((m = divs(m, t, 25, t)) > N) break;      /* t := t/25 */
//		if ((k += 2) >= RADIX) error(PSTR("܂"));
		k	+= 2;
		while (i < m) u[i++] = 0;
		if (divs(m, t, k, u) > N) break;             /* u := t/k */
		if (k & 2) sub(a, u, a);  else add(a, u, a); /* a := a -+ u */

	    _putc('#');
	}

	_putc('\n');
	t[0] = 4;  for (i = 1; i <= N; i++) t[i] = 0;    /* t := 4 */
	divs(0, t, 239, t);                              /* t := t/239 */
	sub(a, t, a);                                    /* a :=a - t */
	i = m = 0;  k = 1;
	for ( ; ; ) {
		if ((m = divs(m, t, 239, t)) > N) break;     /* t := t/239 */
		if ((m = divs(m, t, 239, t)) > N) break;     /* t := t/239 */
//		if ((k += 2) >= RADIX) error(PSTR("܂"));
		k	+= 2;
		while (i < m) u[i++] = 0;
		if (divs(m, t, k, u) > N) break;             /* u := t/k */
		if (k & 2) add(a, u, a);  else sub(a, u, a); /* a := a +- u */

	    _putc('$');
	}

	print(a);
}

int main(void)
{

    wdt_enable(WDTO_1S);

    usart_init();
    timer_init();
    sei();

    pi();
    for(;;)
    ;

    return 0;
}

